#ifndef cmd_def_h
#define cmd_def_h

/*****************************************************************************
 *
 *
 *  !!!!!!!!  THIS IS AUTOGENERATED FILE, DO NOT EDIT !!!!!!!!
 *
 *
 ****************************************************************************/
#include <stdarg.h>
#include "apitypes.h"
#ifdef __cplusplus
extern "C" {
#endif
struct wifi_cmd_packet;

typedef void (*wifi_cmd_handler)(const void*);

struct wifi_header
{
    uint8  type_hilen;
    uint8  lolen;
    uint8  cls;
    uint8  command;
};
struct wifi_msg
{
    struct wifi_header    hdr;
    uint32               params;
    wifi_cmd_handler       handler;    
};       

const struct wifi_msg * wifi_find_msg_hdr(struct wifi_header hdr);
const struct wifi_msg * wifi_get_msg(uint8 idx) ;
const struct wifi_msg * wifi_get_msg_hdr(struct wifi_header hdr) ;
extern void (*bglib_output)(uint8 len1,uint8* data1,uint16 len2,uint8* data2);
void wifi_send_message(uint8 msgid,...);

enum system_main_state
{
	system_idle       = 1,
	system_powered    = 2,
	system_connecting = 4,
	system_connected  = 8,
	system_main_state_max= 9
};

enum endpoint_types
{
	endpoint_free       = 0,
	endpoint_uart       = 1,
	endpoint_usb        = 2,
	endpoint_tcp        = 4,
	endpoint_tcp_server = 8,
	endpoint_udp        = 16,
	endpoint_udp_server = 32,
	endpoint_script     = 64,
	endpoint_wait_close = 128,
	endpoint_types_max  = 129
};


enum wifi_parameter_types
{
    wifi_msg_parameter_uint8=2,
    wifi_msg_parameter_int8=3,
    wifi_msg_parameter_uint16=4,
    wifi_msg_parameter_int16=5,
    wifi_msg_parameter_uint32=6,
    wifi_msg_parameter_int32=7,
    wifi_msg_parameter_uint8array=8,
    wifi_msg_parameter_string=9,
    wifi_msg_parameter_hwaddr=10
};

enum wifi_msg_types
{
    wifi_msg_type_cmd=0x00,
    wifi_msg_type_rsp=0x00,
    wifi_msg_type_evt=0x80,
};
enum wifi_dev_types
{
    wifi_dev_type_ble    =0x00,
    wifi_dev_type_wifi   =0x08,
    wifi_dev_type_iwrap  =0x10,
};

enum wifi_classes
{
	wifi_cls_dfu,
	wifi_cls_system,
	wifi_cls_config,
	wifi_cls_sme,
	wifi_cls_tcpip,
	wifi_cls_endpoint,
	wifi_cls_hardware,
	wifi_cls_flash,
	wifi_cls_last
};
enum wifi_command_ids
{
	wifi_cmd_dfu_reset_id=0,
	wifi_cmd_dfu_flash_set_address_id=1,
	wifi_cmd_dfu_flash_upload_id=2,
	wifi_cmd_dfu_flash_upload_finish_id=3,
	wifi_cmd_system_sync_id=0,
	wifi_cmd_system_reset_id=1,
	wifi_cmd_system_hello_id=2,
	wifi_cmd_config_get_mac_id=0,
	wifi_cmd_config_set_mac_id=1,
	wifi_cmd_sme_wifi_on_id=0,
	wifi_cmd_sme_wifi_off_id=1,
	wifi_cmd_sme_power_on_id=2,
	wifi_cmd_sme_start_scan_id=3,
	wifi_cmd_sme_stop_scan_id=4,
	wifi_cmd_sme_set_password_id=5,
	wifi_cmd_sme_connect_bssid_id=6,
	wifi_cmd_sme_connect_ssid_id=7,
	wifi_cmd_sme_disconnect_id=8,
	wifi_cmd_tcpip_start_tcp_server_id=0,
	wifi_cmd_tcpip_tcp_connect_id=1,
	wifi_cmd_tcpip_start_udp_server_id=2,
	wifi_cmd_tcpip_udp_connect_id=3,
	wifi_cmd_tcpip_configure_id=4,
	wifi_cmd_tcpip_dns_configure_id=5,
	wifi_cmd_tcpip_dns_gethostbyname_id=6,
	wifi_cmd_endpoint_send_id=0,
	wifi_cmd_endpoint_set_streaming_id=1,
	wifi_cmd_endpoint_set_active_id=2,
	wifi_cmd_endpoint_set_streaming_destination_id=3,
	wifi_cmd_endpoint_close_id=4,
	wifi_cmd_hardware_set_soft_timer_id=0,
	wifi_cmd_hardware_external_interrupt_config_id=1,
	wifi_cmd_hardware_change_notification_config_id=2,
	wifi_cmd_hardware_change_notification_pullup_id=3,
	wifi_cmd_hardware_io_port_config_direction_id=4,
	wifi_cmd_hardware_io_port_config_open_drain_id=5,
	wifi_cmd_hardware_io_port_write_id=6,
	wifi_cmd_hardware_io_port_read_id=7,
	wifi_cmd_flash_ps_defrag_id=0,
	wifi_cmd_flash_ps_dump_id=1,
	wifi_cmd_flash_ps_erase_all_id=2,
	wifi_cmd_flash_ps_save_id=3,
	wifi_cmd_flash_ps_load_id=4,
	wifi_cmd_flash_ps_erase_id=5,
};
enum wifi_response_ids
{
	wifi_rsp_dfu_reset_id=0,
	wifi_rsp_dfu_flash_set_address_id=1,
	wifi_rsp_dfu_flash_upload_id=2,
	wifi_rsp_dfu_flash_upload_finish_id=3,
	wifi_rsp_system_sync_id=0,
	wifi_rsp_system_reset_id=1,
	wifi_rsp_system_hello_id=2,
	wifi_rsp_config_get_mac_id=0,
	wifi_rsp_config_set_mac_id=1,
	wifi_rsp_sme_wifi_on_id=0,
	wifi_rsp_sme_wifi_off_id=1,
	wifi_rsp_sme_power_on_id=2,
	wifi_rsp_sme_start_scan_id=3,
	wifi_rsp_sme_stop_scan_id=4,
	wifi_rsp_sme_set_password_id=5,
	wifi_rsp_sme_connect_bssid_id=6,
	wifi_rsp_sme_connect_ssid_id=7,
	wifi_rsp_sme_disconnect_id=8,
	wifi_rsp_tcpip_start_tcp_server_id=0,
	wifi_rsp_tcpip_tcp_connect_id=1,
	wifi_rsp_tcpip_start_udp_server_id=2,
	wifi_rsp_tcpip_udp_connect_id=3,
	wifi_rsp_tcpip_configure_id=4,
	wifi_rsp_tcpip_dns_configure_id=5,
	wifi_rsp_tcpip_dns_gethostbyname_id=6,
	wifi_rsp_endpoint_send_id=0,
	wifi_rsp_endpoint_set_streaming_id=1,
	wifi_rsp_endpoint_set_active_id=2,
	wifi_rsp_endpoint_set_streaming_destination_id=3,
	wifi_rsp_endpoint_close_id=4,
	wifi_rsp_hardware_set_soft_timer_id=0,
	wifi_rsp_hardware_external_interrupt_config_id=1,
	wifi_rsp_hardware_change_notification_config_id=2,
	wifi_rsp_hardware_change_notification_pullup_id=3,
	wifi_rsp_hardware_io_port_config_direction_id=4,
	wifi_rsp_hardware_io_port_config_open_drain_id=5,
	wifi_rsp_hardware_io_port_write_id=6,
	wifi_rsp_hardware_io_port_read_id=7,
	wifi_rsp_flash_ps_defrag_id=0,
	wifi_rsp_flash_ps_dump_id=1,
	wifi_rsp_flash_ps_erase_all_id=2,
	wifi_rsp_flash_ps_save_id=3,
	wifi_rsp_flash_ps_load_id=4,
	wifi_rsp_flash_ps_erase_id=5,
};
enum wifi_event_ids
{
	wifi_evt_dfu_boot_id=0,
	wifi_evt_system_boot_id=0,
	wifi_evt_system_state_id=1,
	wifi_evt_system_sw_exception_id=2,
	wifi_evt_config_mac_address_id=0,
	wifi_evt_sme_wifi_is_on_id=0,
	wifi_evt_sme_wifi_is_off_id=1,
	wifi_evt_sme_scan_result_id=2,
	wifi_evt_sme_scan_result_drop_id=3,
	wifi_evt_sme_scanned_id=4,
	wifi_evt_sme_connected_id=5,
	wifi_evt_sme_disconnected_id=6,
	wifi_evt_sme_interface_status_id=7,
	wifi_evt_sme_connect_failed_id=8,
	wifi_evt_sme_connect_retry_id=9,
	wifi_evt_tcpip_configuration_id=0,
	wifi_evt_tcpip_dns_configuration_id=1,
	wifi_evt_tcpip_endpoint_status_id=2,
	wifi_evt_tcpip_dns_gethostbyname_result_id=3,
	wifi_evt_endpoint_syntax_error_id=0,
	wifi_evt_endpoint_data_id=1,
	wifi_evt_endpoint_status_id=2,
	wifi_evt_endpoint_closing_id=3,
	wifi_evt_hardware_soft_timer_id=0,
	wifi_evt_hardware_change_notification_id=1,
	wifi_evt_hardware_external_interrupt_id=2,
	wifi_evt_flash_ps_key_id=0,
};
enum wifi_msg_idx
{
	wifi_cmd_dfu_reset_idx =0,
	wifi_cmd_dfu_flash_set_address_idx =1,
	wifi_cmd_dfu_flash_upload_idx =2,
	wifi_cmd_dfu_flash_upload_finish_idx =3,
	wifi_cmd_system_sync_idx =4,
	wifi_cmd_system_reset_idx =5,
	wifi_cmd_system_hello_idx =6,
	wifi_cmd_config_get_mac_idx =7,
	wifi_cmd_config_set_mac_idx =8,
	wifi_cmd_sme_wifi_on_idx =9,
	wifi_cmd_sme_wifi_off_idx =10,
	wifi_cmd_sme_power_on_idx =11,
	wifi_cmd_sme_start_scan_idx =12,
	wifi_cmd_sme_stop_scan_idx =13,
	wifi_cmd_sme_set_password_idx =14,
	wifi_cmd_sme_connect_bssid_idx =15,
	wifi_cmd_sme_connect_ssid_idx =16,
	wifi_cmd_sme_disconnect_idx =17,
	wifi_cmd_tcpip_start_tcp_server_idx =18,
	wifi_cmd_tcpip_tcp_connect_idx =19,
	wifi_cmd_tcpip_start_udp_server_idx =20,
	wifi_cmd_tcpip_udp_connect_idx =21,
	wifi_cmd_tcpip_configure_idx =22,
	wifi_cmd_tcpip_dns_configure_idx =23,
	wifi_cmd_tcpip_dns_gethostbyname_idx =24,
	wifi_cmd_endpoint_send_idx =25,
	wifi_cmd_endpoint_set_streaming_idx =26,
	wifi_cmd_endpoint_set_active_idx =27,
	wifi_cmd_endpoint_set_streaming_destination_idx =28,
	wifi_cmd_endpoint_close_idx =29,
	wifi_cmd_hardware_set_soft_timer_idx =30,
	wifi_cmd_hardware_external_interrupt_config_idx =31,
	wifi_cmd_hardware_change_notification_config_idx =32,
	wifi_cmd_hardware_change_notification_pullup_idx =33,
	wifi_cmd_hardware_io_port_config_direction_idx =34,
	wifi_cmd_hardware_io_port_config_open_drain_idx =35,
	wifi_cmd_hardware_io_port_write_idx =36,
	wifi_cmd_hardware_io_port_read_idx =37,
	wifi_cmd_flash_ps_defrag_idx =38,
	wifi_cmd_flash_ps_dump_idx =39,
	wifi_cmd_flash_ps_erase_all_idx =40,
	wifi_cmd_flash_ps_save_idx =41,
	wifi_cmd_flash_ps_load_idx =42,
	wifi_cmd_flash_ps_erase_idx =43,
	wifi_rsp_dfu_reset_idx =44,
	wifi_rsp_dfu_flash_set_address_idx =45,
	wifi_rsp_dfu_flash_upload_idx =46,
	wifi_rsp_dfu_flash_upload_finish_idx =47,
	wifi_rsp_system_sync_idx =48,
	wifi_rsp_system_reset_idx =49,
	wifi_rsp_system_hello_idx =50,
	wifi_rsp_config_get_mac_idx =51,
	wifi_rsp_config_set_mac_idx =52,
	wifi_rsp_sme_wifi_on_idx =53,
	wifi_rsp_sme_wifi_off_idx =54,
	wifi_rsp_sme_power_on_idx =55,
	wifi_rsp_sme_start_scan_idx =56,
	wifi_rsp_sme_stop_scan_idx =57,
	wifi_rsp_sme_set_password_idx =58,
	wifi_rsp_sme_connect_bssid_idx =59,
	wifi_rsp_sme_connect_ssid_idx =60,
	wifi_rsp_sme_disconnect_idx =61,
	wifi_rsp_tcpip_start_tcp_server_idx =62,
	wifi_rsp_tcpip_tcp_connect_idx =63,
	wifi_rsp_tcpip_start_udp_server_idx =64,
	wifi_rsp_tcpip_udp_connect_idx =65,
	wifi_rsp_tcpip_configure_idx =66,
	wifi_rsp_tcpip_dns_configure_idx =67,
	wifi_rsp_tcpip_dns_gethostbyname_idx =68,
	wifi_rsp_endpoint_send_idx =69,
	wifi_rsp_endpoint_set_streaming_idx =70,
	wifi_rsp_endpoint_set_active_idx =71,
	wifi_rsp_endpoint_set_streaming_destination_idx =72,
	wifi_rsp_endpoint_close_idx =73,
	wifi_rsp_hardware_set_soft_timer_idx =74,
	wifi_rsp_hardware_external_interrupt_config_idx =75,
	wifi_rsp_hardware_change_notification_config_idx =76,
	wifi_rsp_hardware_change_notification_pullup_idx =77,
	wifi_rsp_hardware_io_port_config_direction_idx =78,
	wifi_rsp_hardware_io_port_config_open_drain_idx =79,
	wifi_rsp_hardware_io_port_write_idx =80,
	wifi_rsp_hardware_io_port_read_idx =81,
	wifi_rsp_flash_ps_defrag_idx =82,
	wifi_rsp_flash_ps_dump_idx =83,
	wifi_rsp_flash_ps_erase_all_idx =84,
	wifi_rsp_flash_ps_save_idx =85,
	wifi_rsp_flash_ps_load_idx =86,
	wifi_rsp_flash_ps_erase_idx =87,
	wifi_evt_dfu_boot_idx =88,
	wifi_evt_system_boot_idx =89,
	wifi_evt_system_state_idx =90,
	wifi_evt_system_sw_exception_idx =91,
	wifi_evt_config_mac_address_idx =92,
	wifi_evt_sme_wifi_is_on_idx =93,
	wifi_evt_sme_wifi_is_off_idx =94,
	wifi_evt_sme_scan_result_idx =95,
	wifi_evt_sme_scan_result_drop_idx =96,
	wifi_evt_sme_scanned_idx =97,
	wifi_evt_sme_connected_idx =98,
	wifi_evt_sme_disconnected_idx =99,
	wifi_evt_sme_interface_status_idx =100,
	wifi_evt_sme_connect_failed_idx =101,
	wifi_evt_sme_connect_retry_idx =102,
	wifi_evt_tcpip_configuration_idx =103,
	wifi_evt_tcpip_dns_configuration_idx =104,
	wifi_evt_tcpip_endpoint_status_idx =105,
	wifi_evt_tcpip_dns_gethostbyname_result_idx =106,
	wifi_evt_endpoint_syntax_error_idx =107,
	wifi_evt_endpoint_data_idx =108,
	wifi_evt_endpoint_status_idx =109,
	wifi_evt_endpoint_closing_idx =110,
	wifi_evt_hardware_soft_timer_idx =111,
	wifi_evt_hardware_change_notification_idx =112,
	wifi_evt_hardware_external_interrupt_idx =113,
	wifi_evt_flash_ps_key_idx =114,
};
enum wifi_error_spaces
{
	wifi_err_bg=256,
	wifi_err_tcpip=512,
};
enum wifi_error
{
	wifi_err_success                =0,                //No error
	wifi_err_invalid_param          =wifi_err_bg+128,  //Command contained invalid parameter
	wifi_err_wrong_state            =wifi_err_bg+129,  //Device is in wrong state to accept command
	wifi_err_out_of_memory          =wifi_err_bg+130,  //Device has run out of memory
	wifi_err_not_implemented        =wifi_err_bg+131,  //Feature is not implemented
	wifi_err_invalid_command        =wifi_err_bg+132,  //Command was not recognized
	wifi_err_timeout                =wifi_err_bg+133,  //Command or Procedure failed due to timeout
	wifi_err_unspecified            =wifi_err_bg+134,  //Unspecified error
	wifi_err_hardware               =wifi_err_bg+135,  //Hardware failure
	wifi_err_tcpip_success          =wifi_err_tcpip+0, //No error
	wifi_err_tcpip_out_of_memory    =wifi_err_tcpip+1, //Out of memory
	wifi_err_tcpip_buffer           =wifi_err_tcpip+2, //Buffer handling failed
	wifi_err_tcpip_timeout          =wifi_err_tcpip+3, //Timeout
	wifi_err_tcpip_routing          =wifi_err_tcpip+4, //Could not find route
	wifi_err_tcpip_in_use           =wifi_err_tcpip+8, //Address in use
	wifi_err_tcpip_already_connected=wifi_err_tcpip+9, //Already connected
	wifi_err_tcpip_abort            =wifi_err_tcpip+10,//Connection aborted
	wifi_err_tcpip_reset            =wifi_err_tcpip+11,//Connection reset
	wifi_err_tcpip_closed           =wifi_err_tcpip+12,//Connection closed
	wifi_err_tcpip_not_connected    =wifi_err_tcpip+13,//Not connected
	wifi_err_tcpip_interface        =wifi_err_tcpip+15,//Interface error
	wifi_err_last
};
struct wifi_msg_dfu_reset_cmd_t
{
	uint8	dfu;
}PACKED;

struct wifi_msg_dfu_flash_set_address_cmd_t
{
	uint32	address;
}PACKED;

struct wifi_msg_dfu_flash_set_address_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_dfu_flash_upload_cmd_t
{
	uint8array	data;
}PACKED;

struct wifi_msg_dfu_flash_upload_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_dfu_flash_upload_finish_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_dfu_boot_evt_t
{
	uint32	version;
}PACKED;

struct wifi_msg_system_reset_cmd_t
{
	uint8	dfu;
}PACKED;

struct wifi_msg_system_boot_evt_t
{
	uint16	major;
	uint16	minor;
	uint16	patch;
	uint16	build;
	uint16	bootloader_version;
	uint16	tcpip_version;
	uint16	hw;
}PACKED;

struct wifi_msg_system_state_evt_t
{
	uint16	state;
}PACKED;

struct wifi_msg_system_sw_exception_evt_t
{
	uint32	address;
	uint8	type;
}PACKED;

struct wifi_msg_config_get_mac_cmd_t
{
	uint8	hw_interface;
}PACKED;

struct wifi_msg_config_get_mac_rsp_t
{
	uint16	result;
	uint8	hw_interface;
}PACKED;

struct wifi_msg_config_set_mac_cmd_t
{
	uint8	hw_interface;
	hw_addr	mac;
}PACKED;

struct wifi_msg_config_set_mac_rsp_t
{
	uint16	result;
	uint8	hw_interface;
}PACKED;

struct wifi_msg_config_mac_address_evt_t
{
	uint8	hw_interface;
	hw_addr	mac;
}PACKED;

struct wifi_msg_sme_wifi_on_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_wifi_off_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_power_on_cmd_t
{
	uint8	enable;
}PACKED;

struct wifi_msg_sme_power_on_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_start_scan_cmd_t
{
	uint8	handle;
	uint8array	chList;
}PACKED;

struct wifi_msg_sme_start_scan_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_stop_scan_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_set_password_cmd_t
{
	uint8array	password;
}PACKED;

struct wifi_msg_sme_set_password_rsp_t
{
	uint8	status;
}PACKED;

struct wifi_msg_sme_connect_bssid_cmd_t
{
	hw_addr	bssid;
}PACKED;

struct wifi_msg_sme_connect_bssid_rsp_t
{
	uint16	result;
	uint8	hw_interface;
	hw_addr	bssid;
}PACKED;

struct wifi_msg_sme_connect_ssid_cmd_t
{
	uint8array	ssid;
}PACKED;

struct wifi_msg_sme_connect_ssid_rsp_t
{
	uint16	result;
	uint8	hw_interface;
	hw_addr	bssid;
}PACKED;

struct wifi_msg_sme_disconnect_rsp_t
{
	uint16	result;
	uint8	hw_interface;
}PACKED;

struct wifi_msg_sme_wifi_is_on_evt_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_wifi_is_off_evt_t
{
	uint16	result;
}PACKED;

struct wifi_msg_sme_scan_result_evt_t
{
	hw_addr	bssid;
	int8	channel;
	int16	rssi;
	int8	snr;
	uint8	secure;
	uint8array	ssid;
}PACKED;

struct wifi_msg_sme_scan_result_drop_evt_t
{
	hw_addr	bssid;
}PACKED;

struct wifi_msg_sme_scanned_evt_t
{
	int8	status;
}PACKED;

struct wifi_msg_sme_connected_evt_t
{
	int8	status;
	uint8	hw_interface;
	hw_addr	bssid;
}PACKED;

struct wifi_msg_sme_disconnected_evt_t
{
	uint16	reason;
	uint8	hw_interface;
}PACKED;

struct wifi_msg_sme_interface_status_evt_t
{
	uint8	hw_interface;
	uint8	status;
}PACKED;

struct wifi_msg_sme_connect_failed_evt_t
{
	uint16	reason;
	uint8	hw_interface;
}PACKED;

struct wifi_msg_sme_connect_retry_evt_t
{
	uint8	hw_interface;
}PACKED;

struct wifi_msg_tcpip_start_tcp_server_cmd_t
{
	uint16	port;
	int8	default_destination;
}PACKED;

struct wifi_msg_tcpip_start_tcp_server_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_tcpip_tcp_connect_cmd_t
{
	ipv4	address;
	uint16	port;
	int8	routing;
}PACKED;

struct wifi_msg_tcpip_tcp_connect_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_tcpip_start_udp_server_cmd_t
{
	uint16	port;
	int8	default_destination;
}PACKED;

struct wifi_msg_tcpip_start_udp_server_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_tcpip_udp_connect_cmd_t
{
	ipv4	address;
	uint16	port;
	int8	routing;
}PACKED;

struct wifi_msg_tcpip_udp_connect_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_tcpip_configure_cmd_t
{
	ipv4	address;
	ipv4	netmask;
	ipv4	gateway;
	uint8	use_dhcp;
}PACKED;

struct wifi_msg_tcpip_configure_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_tcpip_dns_configure_cmd_t
{
	uint8	index;
	ipv4	address;
}PACKED;

struct wifi_msg_tcpip_dns_configure_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_tcpip_dns_gethostbyname_cmd_t
{
	uint8array	name;
}PACKED;

struct wifi_msg_tcpip_dns_gethostbyname_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_tcpip_configuration_evt_t
{
	ipv4	address;
	ipv4	netmask;
	ipv4	gateway;
	uint8	use_dhcp;
}PACKED;

struct wifi_msg_tcpip_dns_configuration_evt_t
{
	uint8	index;
	ipv4	address;
}PACKED;

struct wifi_msg_tcpip_endpoint_status_evt_t
{
	uint8	endpoint;
	ipv4	local_ip;
	uint16	local_port;
	ipv4	remote_ip;
	uint16	remote_port;
}PACKED;

struct wifi_msg_tcpip_dns_gethostbyname_result_evt_t
{
	uint16	result;
	ipv4	address;
	uint8array	name;
}PACKED;

struct wifi_msg_endpoint_send_cmd_t
{
	uint8	endpoint;
	uint8array	data;
}PACKED;

struct wifi_msg_endpoint_send_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_set_streaming_cmd_t
{
	uint8	endpoint;
	uint8	streaming;
}PACKED;

struct wifi_msg_endpoint_set_streaming_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_set_active_cmd_t
{
	uint8	endpoint;
	uint8	active;
}PACKED;

struct wifi_msg_endpoint_set_active_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_set_streaming_destination_cmd_t
{
	uint8	endpoint;
	int8	streaming_destination;
}PACKED;

struct wifi_msg_endpoint_set_streaming_destination_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_close_cmd_t
{
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_close_rsp_t
{
	uint16	result;
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_syntax_error_evt_t
{
	uint8	endpoint;
}PACKED;

struct wifi_msg_endpoint_data_evt_t
{
	uint8	endpoint;
	uint8array	data;
}PACKED;

struct wifi_msg_endpoint_status_evt_t
{
	uint8	endpoint;
	uint8	type;
	uint8	streaming;
	int8	destination;
	uint8	active;
}PACKED;

struct wifi_msg_endpoint_closing_evt_t
{
	uint16	reason;
	uint8	endpoint;
}PACKED;

struct wifi_msg_hardware_set_soft_timer_cmd_t
{
	uint32	time;
	uint8	handle;
	uint8	single_shot;
}PACKED;

struct wifi_msg_hardware_set_soft_timer_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_external_interrupt_config_cmd_t
{
	uint8	enable;
	uint8	polarity;
}PACKED;

struct wifi_msg_hardware_external_interrupt_config_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_change_notification_config_cmd_t
{
	uint32	enable;
}PACKED;

struct wifi_msg_hardware_change_notification_config_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_change_notification_pullup_cmd_t
{
	uint32	pullup;
}PACKED;

struct wifi_msg_hardware_change_notification_pullup_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_io_port_config_direction_cmd_t
{
	uint8	port;
	uint16	mask;
	uint16	direction;
}PACKED;

struct wifi_msg_hardware_io_port_config_direction_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_io_port_config_open_drain_cmd_t
{
	uint8	port;
	uint16	mask;
	uint16	open_drain;
}PACKED;

struct wifi_msg_hardware_io_port_config_open_drain_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_io_port_write_cmd_t
{
	uint8	port;
	uint16	mask;
	uint16	data;
}PACKED;

struct wifi_msg_hardware_io_port_write_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_hardware_io_port_read_cmd_t
{
	uint8	port;
	uint16	mask;
}PACKED;

struct wifi_msg_hardware_io_port_read_rsp_t
{
	uint16	result;
	uint8	port;
	uint16	data;
}PACKED;

struct wifi_msg_hardware_soft_timer_evt_t
{
	uint8	handle;
}PACKED;

struct wifi_msg_hardware_change_notification_evt_t
{
	uint32	timestamp;
}PACKED;

struct wifi_msg_hardware_external_interrupt_evt_t
{
	uint8	irq;
	uint32	timestamp;
}PACKED;

struct wifi_msg_flash_ps_defrag_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_flash_ps_dump_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_flash_ps_erase_all_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_flash_ps_save_cmd_t
{
	uint16	key;
	uint8array	value;
}PACKED;

struct wifi_msg_flash_ps_save_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_flash_ps_load_cmd_t
{
	uint16	key;
}PACKED;

struct wifi_msg_flash_ps_load_rsp_t
{
	uint16	result;
	uint8array	value;
}PACKED;

struct wifi_msg_flash_ps_erase_cmd_t
{
	uint16	key;
}PACKED;

struct wifi_msg_flash_ps_erase_rsp_t
{
	uint16	result;
}PACKED;

struct wifi_msg_flash_ps_key_evt_t
{
	uint16	key;
	uint8array	value;
}PACKED;


struct wifi_cmd_packet
{
	struct wifi_header header;

union{
	uint8 handle;

	uint8 payload;

	struct wifi_msg_dfu_reset_cmd_t dfu_reset_cmd;

	struct wifi_msg_dfu_flash_set_address_cmd_t dfu_flash_set_address_cmd;

	struct wifi_msg_dfu_flash_upload_cmd_t dfu_flash_upload_cmd;

	struct wifi_msg_dfu_boot_evt_t dfu_boot_evt;

	struct wifi_msg_system_reset_cmd_t system_reset_cmd;

	struct wifi_msg_system_boot_evt_t system_boot_evt;

	struct wifi_msg_system_state_evt_t system_state_evt;

	struct wifi_msg_system_sw_exception_evt_t system_sw_exception_evt;

	struct wifi_msg_config_get_mac_cmd_t config_get_mac_cmd;

	struct wifi_msg_config_set_mac_cmd_t config_set_mac_cmd;

	struct wifi_msg_config_mac_address_evt_t config_mac_address_evt;

	struct wifi_msg_sme_power_on_cmd_t sme_power_on_cmd;

	struct wifi_msg_sme_start_scan_cmd_t sme_start_scan_cmd;

	struct wifi_msg_sme_set_password_cmd_t sme_set_password_cmd;

	struct wifi_msg_sme_connect_bssid_cmd_t sme_connect_bssid_cmd;

	struct wifi_msg_sme_connect_ssid_cmd_t sme_connect_ssid_cmd;

	struct wifi_msg_sme_wifi_is_on_evt_t sme_wifi_is_on_evt;

	struct wifi_msg_sme_wifi_is_off_evt_t sme_wifi_is_off_evt;

	struct wifi_msg_sme_scan_result_evt_t sme_scan_result_evt;

	struct wifi_msg_sme_scan_result_drop_evt_t sme_scan_result_drop_evt;

	struct wifi_msg_sme_scanned_evt_t sme_scanned_evt;

	struct wifi_msg_sme_connected_evt_t sme_connected_evt;

	struct wifi_msg_sme_disconnected_evt_t sme_disconnected_evt;

	struct wifi_msg_sme_interface_status_evt_t sme_interface_status_evt;

	struct wifi_msg_sme_connect_failed_evt_t sme_connect_failed_evt;

	struct wifi_msg_sme_connect_retry_evt_t sme_connect_retry_evt;

	struct wifi_msg_tcpip_start_tcp_server_cmd_t tcpip_start_tcp_server_cmd;

	struct wifi_msg_tcpip_tcp_connect_cmd_t tcpip_tcp_connect_cmd;

	struct wifi_msg_tcpip_start_udp_server_cmd_t tcpip_start_udp_server_cmd;

	struct wifi_msg_tcpip_udp_connect_cmd_t tcpip_udp_connect_cmd;

	struct wifi_msg_tcpip_configure_cmd_t tcpip_configure_cmd;

	struct wifi_msg_tcpip_dns_configure_cmd_t tcpip_dns_configure_cmd;

	struct wifi_msg_tcpip_dns_gethostbyname_cmd_t tcpip_dns_gethostbyname_cmd;

	struct wifi_msg_tcpip_configuration_evt_t tcpip_configuration_evt;

	struct wifi_msg_tcpip_dns_configuration_evt_t tcpip_dns_configuration_evt;

	struct wifi_msg_tcpip_endpoint_status_evt_t tcpip_endpoint_status_evt;

	struct wifi_msg_tcpip_dns_gethostbyname_result_evt_t tcpip_dns_gethostbyname_result_evt;

	struct wifi_msg_endpoint_send_cmd_t endpoint_send_cmd;

	struct wifi_msg_endpoint_set_streaming_cmd_t endpoint_set_streaming_cmd;

	struct wifi_msg_endpoint_set_active_cmd_t endpoint_set_active_cmd;

	struct wifi_msg_endpoint_set_streaming_destination_cmd_t endpoint_set_streaming_destination_cmd;

	struct wifi_msg_endpoint_close_cmd_t endpoint_close_cmd;

	struct wifi_msg_endpoint_syntax_error_evt_t endpoint_syntax_error_evt;

	struct wifi_msg_endpoint_data_evt_t endpoint_data_evt;

	struct wifi_msg_endpoint_status_evt_t endpoint_status_evt;

	struct wifi_msg_endpoint_closing_evt_t endpoint_closing_evt;

	struct wifi_msg_hardware_set_soft_timer_cmd_t hardware_set_soft_timer_cmd;

	struct wifi_msg_hardware_external_interrupt_config_cmd_t hardware_external_interrupt_config_cmd;

	struct wifi_msg_hardware_change_notification_config_cmd_t hardware_change_notification_config_cmd;

	struct wifi_msg_hardware_change_notification_pullup_cmd_t hardware_change_notification_pullup_cmd;

	struct wifi_msg_hardware_io_port_config_direction_cmd_t hardware_io_port_config_direction_cmd;

	struct wifi_msg_hardware_io_port_config_open_drain_cmd_t hardware_io_port_config_open_drain_cmd;

	struct wifi_msg_hardware_io_port_write_cmd_t hardware_io_port_write_cmd;

	struct wifi_msg_hardware_io_port_read_cmd_t hardware_io_port_read_cmd;

	struct wifi_msg_hardware_soft_timer_evt_t hardware_soft_timer_evt;

	struct wifi_msg_hardware_change_notification_evt_t hardware_change_notification_evt;

	struct wifi_msg_hardware_external_interrupt_evt_t hardware_external_interrupt_evt;

	struct wifi_msg_flash_ps_save_cmd_t flash_ps_save_cmd;

	struct wifi_msg_flash_ps_load_cmd_t flash_ps_load_cmd;

	struct wifi_msg_flash_ps_erase_cmd_t flash_ps_erase_cmd;

	struct wifi_msg_flash_ps_key_evt_t flash_ps_key_evt;

};

}ALIGNED;
/**Reset system**/
#define wifi_cmd_dfu_reset(dfu) wifi_send_message (wifi_cmd_dfu_reset_idx,dfu)
/**set address for flashing**/
#define wifi_cmd_dfu_flash_set_address(address) wifi_send_message (wifi_cmd_dfu_flash_set_address_idx,address)
/**Upload binary for flashing. Address will be updated automatically.**/
#define wifi_cmd_dfu_flash_upload(data_len,data_data) wifi_send_message (wifi_cmd_dfu_flash_upload_idx,data_len,data_data)
/**Uploading is finished.**/
#define wifi_cmd_dfu_flash_upload_finish() wifi_send_message (wifi_cmd_dfu_flash_upload_finish_idx)
/**Sync system state**/
#define wifi_cmd_system_sync() wifi_send_message (wifi_cmd_system_sync_idx)
/**Reset system**/
#define wifi_cmd_system_reset(dfu) wifi_send_message (wifi_cmd_system_reset_idx,dfu)
/**Hello (no-op)**/
#define wifi_cmd_system_hello() wifi_send_message (wifi_cmd_system_hello_idx)
/**Get MAC address**/
#define wifi_cmd_config_get_mac(hw_interface) wifi_send_message (wifi_cmd_config_get_mac_idx,hw_interface)
/**Set MAC address**/
#define wifi_cmd_config_set_mac(hw_interface,mac) wifi_send_message (wifi_cmd_config_set_mac_idx,hw_interface,mac)
/**Turn Wi-Fi on**/
#define wifi_cmd_sme_wifi_on() wifi_send_message (wifi_cmd_sme_wifi_on_idx)
/**Turn wifi off**/
#define wifi_cmd_sme_wifi_off() wifi_send_message (wifi_cmd_sme_wifi_off_idx)
/**Turn on or off the power to the Wi-Fi chip**/
#define wifi_cmd_sme_power_on(enable) wifi_send_message (wifi_cmd_sme_power_on_idx,enable)
/**Initiate the scan procedure**/
#define wifi_cmd_sme_start_scan(handle,chList_len,chList_data) wifi_send_message (wifi_cmd_sme_start_scan_idx,handle,chList_len,chList_data)
/**Terminate the scan procedure**/
#define wifi_cmd_sme_stop_scan() wifi_send_message (wifi_cmd_sme_stop_scan_idx)
/**Set the Wi-Fi password**/
#define wifi_cmd_sme_set_password(password_len,password_data) wifi_send_message (wifi_cmd_sme_set_password_idx,password_len,password_data)
/**Connect to a specific Access Point using its unique BSSID**/
#define wifi_cmd_sme_connect_bssid(bssid) wifi_send_message (wifi_cmd_sme_connect_bssid_idx,bssid)
/**Connect to an Access Point which belongs to the network identified with the given SSID**/
#define wifi_cmd_sme_connect_ssid(ssid_len,ssid_data) wifi_send_message (wifi_cmd_sme_connect_ssid_idx,ssid_len,ssid_data)
/**Disconnect from the Access Point**/
#define wifi_cmd_sme_disconnect() wifi_send_message (wifi_cmd_sme_disconnect_idx)
/**Start TCP server**/
#define wifi_cmd_tcpip_start_tcp_server(port,default_destination) wifi_send_message (wifi_cmd_tcpip_start_tcp_server_idx,port,default_destination)
/**Attempt to create a new TCP connection**/
#define wifi_cmd_tcpip_tcp_connect(address,port,routing) wifi_send_message (wifi_cmd_tcpip_tcp_connect_idx,address,port,routing)
/**Create a new UDP Server**/
#define wifi_cmd_tcpip_start_udp_server(port,default_destination) wifi_send_message (wifi_cmd_tcpip_start_udp_server_idx,port,default_destination)
/**Create a new UDP connection**/
#define wifi_cmd_tcpip_udp_connect(address,port,routing) wifi_send_message (wifi_cmd_tcpip_udp_connect_idx,address,port,routing)
/**Configure TCP/IP**/
#define wifi_cmd_tcpip_configure(address,netmask,gateway,use_dhcp) wifi_send_message (wifi_cmd_tcpip_configure_idx,address,netmask,gateway,use_dhcp)
/**Configure DNS**/
#define wifi_cmd_tcpip_dns_configure(index,address) wifi_send_message (wifi_cmd_tcpip_dns_configure_idx,index,address)
/**Start resolving a hostname into an IP address using the configured DNS server**/
#define wifi_cmd_tcpip_dns_gethostbyname(name_len,name_data) wifi_send_message (wifi_cmd_tcpip_dns_gethostbyname_idx,name_len,name_data)
/**Send data to a given endpoint**/
#define wifi_cmd_endpoint_send(endpoint,data_len,data_data) wifi_send_message (wifi_cmd_endpoint_send_idx,endpoint,data_len,data_data)
/**set streaming mode**/
#define wifi_cmd_endpoint_set_streaming(endpoint,streaming) wifi_send_message (wifi_cmd_endpoint_set_streaming_idx,endpoint,streaming)
/**set active status**/
#define wifi_cmd_endpoint_set_active(endpoint,active) wifi_send_message (wifi_cmd_endpoint_set_active_idx,endpoint,active)
/**set destination for streaming mode**/
#define wifi_cmd_endpoint_set_streaming_destination(endpoint,streaming_destination) wifi_send_message (wifi_cmd_endpoint_set_streaming_destination_idx,endpoint,streaming_destination)
/**Close the endpoint**/
#define wifi_cmd_endpoint_close(endpoint) wifi_send_message (wifi_cmd_endpoint_close_idx,endpoint)
/**Set soft timer to send events**/
#define wifi_cmd_hardware_set_soft_timer(time,handle,single_shot) wifi_send_message (wifi_cmd_hardware_set_soft_timer_idx,time,handle,single_shot)
/**Configure external interrupt**/
#define wifi_cmd_hardware_external_interrupt_config(enable,polarity) wifi_send_message (wifi_cmd_hardware_external_interrupt_config_idx,enable,polarity)
/**Configure change notification**/
#define wifi_cmd_hardware_change_notification_config(enable) wifi_send_message (wifi_cmd_hardware_change_notification_config_idx,enable)
/**Configure change notification pull-up**/
#define wifi_cmd_hardware_change_notification_pullup(pullup) wifi_send_message (wifi_cmd_hardware_change_notification_pullup_idx,pullup)
/**Configure I/O-port direction**/
#define wifi_cmd_hardware_io_port_config_direction(port,mask,direction) wifi_send_message (wifi_cmd_hardware_io_port_config_direction_idx,port,mask,direction)
/**Configure I/O-port open drain**/
#define wifi_cmd_hardware_io_port_config_open_drain(port,mask,open_drain) wifi_send_message (wifi_cmd_hardware_io_port_config_open_drain_idx,port,mask,open_drain)
/**Set the pins of an I/O-port**/
#define wifi_cmd_hardware_io_port_write(port,mask,data) wifi_send_message (wifi_cmd_hardware_io_port_write_idx,port,mask,data)
/**Read the pins of an I/O-port**/
#define wifi_cmd_hardware_io_port_read(port,mask) wifi_send_message (wifi_cmd_hardware_io_port_read_idx,port,mask)
/**Defragment persistent store**/
#define wifi_cmd_flash_ps_defrag() wifi_send_message (wifi_cmd_flash_ps_defrag_idx)
/**Dump all ps keys**/
#define wifi_cmd_flash_ps_dump() wifi_send_message (wifi_cmd_flash_ps_dump_idx)
/**Erase all ps keys. Warning: This will erase the device's MAC address!**/
#define wifi_cmd_flash_ps_erase_all() wifi_send_message (wifi_cmd_flash_ps_erase_all_idx)
/**Store a value to the given key in the persistent store**/
#define wifi_cmd_flash_ps_save(key,value_len,value_data) wifi_send_message (wifi_cmd_flash_ps_save_idx,key,value_len,value_data)
/**Retrieve the value from the persistent store for the given key **/
#define wifi_cmd_flash_ps_load(key) wifi_send_message (wifi_cmd_flash_ps_load_idx,key)
/**Erase the key and value from the persisten store.**/
#define wifi_cmd_flash_ps_erase(key) wifi_send_message (wifi_cmd_flash_ps_erase_idx,key)
/**Reset system**/
void wifi_rsp_dfu_reset(const void *nul);

/**set address for flashing**/
void wifi_rsp_dfu_flash_set_address(const struct wifi_msg_dfu_flash_set_address_rsp_t *msg);

/**Upload binary for flashing. Address will be updated automatically.**/
void wifi_rsp_dfu_flash_upload(const struct wifi_msg_dfu_flash_upload_rsp_t *msg);

/**Uploading is finished.**/
void wifi_rsp_dfu_flash_upload_finish(const struct wifi_msg_dfu_flash_upload_finish_rsp_t *msg);

/**Sync system state**/
void wifi_rsp_system_sync(const void *nul);

/**Reset system**/
void wifi_rsp_system_reset(const void *nul);

/**Hello (no-op)**/
void wifi_rsp_system_hello(const void *nul);

/**Get MAC address**/
void wifi_rsp_config_get_mac(const struct wifi_msg_config_get_mac_rsp_t *msg);

/**Set MAC address**/
void wifi_rsp_config_set_mac(const struct wifi_msg_config_set_mac_rsp_t *msg);

/**Turn Wi-Fi on**/
void wifi_rsp_sme_wifi_on(const struct wifi_msg_sme_wifi_on_rsp_t *msg);

/**Turn wifi off**/
void wifi_rsp_sme_wifi_off(const struct wifi_msg_sme_wifi_off_rsp_t *msg);

/**Turn on or off the power to the Wi-Fi chip**/
void wifi_rsp_sme_power_on(const struct wifi_msg_sme_power_on_rsp_t *msg);

/**Initiate the scan procedure**/
void wifi_rsp_sme_start_scan(const struct wifi_msg_sme_start_scan_rsp_t *msg);

/**Terminate the scan procedure**/
void wifi_rsp_sme_stop_scan(const struct wifi_msg_sme_stop_scan_rsp_t *msg);

/**Set the Wi-Fi password**/
void wifi_rsp_sme_set_password(const struct wifi_msg_sme_set_password_rsp_t *msg);

/**Connect to a specific Access Point using its unique BSSID**/
void wifi_rsp_sme_connect_bssid(const struct wifi_msg_sme_connect_bssid_rsp_t *msg);

/**Connect to an Access Point which belongs to the network identified with the given SSID**/
void wifi_rsp_sme_connect_ssid(const struct wifi_msg_sme_connect_ssid_rsp_t *msg);

/**Disconnect from the Access Point**/
void wifi_rsp_sme_disconnect(const struct wifi_msg_sme_disconnect_rsp_t *msg);

/**Start TCP server**/
void wifi_rsp_tcpip_start_tcp_server(const struct wifi_msg_tcpip_start_tcp_server_rsp_t *msg);

/**Attempt to create a new TCP connection**/
void wifi_rsp_tcpip_tcp_connect(const struct wifi_msg_tcpip_tcp_connect_rsp_t *msg);

/**Create a new UDP Server**/
void wifi_rsp_tcpip_start_udp_server(const struct wifi_msg_tcpip_start_udp_server_rsp_t *msg);

/**Create a new UDP connection**/
void wifi_rsp_tcpip_udp_connect(const struct wifi_msg_tcpip_udp_connect_rsp_t *msg);

/**Configure TCP/IP**/
void wifi_rsp_tcpip_configure(const struct wifi_msg_tcpip_configure_rsp_t *msg);

/**Configure DNS**/
void wifi_rsp_tcpip_dns_configure(const struct wifi_msg_tcpip_dns_configure_rsp_t *msg);

/**Start resolving a hostname into an IP address using the configured DNS server**/
void wifi_rsp_tcpip_dns_gethostbyname(const struct wifi_msg_tcpip_dns_gethostbyname_rsp_t *msg);

/**Send data to a given endpoint**/
void wifi_rsp_endpoint_send(const struct wifi_msg_endpoint_send_rsp_t *msg);

/**set streaming mode**/
void wifi_rsp_endpoint_set_streaming(const struct wifi_msg_endpoint_set_streaming_rsp_t *msg);

/**set active status**/
void wifi_rsp_endpoint_set_active(const struct wifi_msg_endpoint_set_active_rsp_t *msg);

/**set destination for streaming mode**/
void wifi_rsp_endpoint_set_streaming_destination(const struct wifi_msg_endpoint_set_streaming_destination_rsp_t *msg);

/**Close the endpoint**/
void wifi_rsp_endpoint_close(const struct wifi_msg_endpoint_close_rsp_t *msg);

/**Set soft timer to send events**/
void wifi_rsp_hardware_set_soft_timer(const struct wifi_msg_hardware_set_soft_timer_rsp_t *msg);

/**Configure external interrupt**/
void wifi_rsp_hardware_external_interrupt_config(const struct wifi_msg_hardware_external_interrupt_config_rsp_t *msg);

/**Configure change notification**/
void wifi_rsp_hardware_change_notification_config(const struct wifi_msg_hardware_change_notification_config_rsp_t *msg);

/**Configure change notification pull-up**/
void wifi_rsp_hardware_change_notification_pullup(const struct wifi_msg_hardware_change_notification_pullup_rsp_t *msg);

/**Configure I/O-port direction**/
void wifi_rsp_hardware_io_port_config_direction(const struct wifi_msg_hardware_io_port_config_direction_rsp_t *msg);

/**Configure I/O-port open drain**/
void wifi_rsp_hardware_io_port_config_open_drain(const struct wifi_msg_hardware_io_port_config_open_drain_rsp_t *msg);

/**Set the pins of an I/O-port**/
void wifi_rsp_hardware_io_port_write(const struct wifi_msg_hardware_io_port_write_rsp_t *msg);

/**Read the pins of an I/O-port**/
void wifi_rsp_hardware_io_port_read(const struct wifi_msg_hardware_io_port_read_rsp_t *msg);

/**Defragment persistent store**/
void wifi_rsp_flash_ps_defrag(const struct wifi_msg_flash_ps_defrag_rsp_t *msg);

/**Dump all ps keys**/
void wifi_rsp_flash_ps_dump(const struct wifi_msg_flash_ps_dump_rsp_t *msg);

/**Erase all ps keys. Warning: This will erase the device's MAC address!**/
void wifi_rsp_flash_ps_erase_all(const struct wifi_msg_flash_ps_erase_all_rsp_t *msg);

/**Store a value to the given key in the persistent store**/
void wifi_rsp_flash_ps_save(const struct wifi_msg_flash_ps_save_rsp_t *msg);

/**Retrieve the value from the persistent store for the given key **/
void wifi_rsp_flash_ps_load(const struct wifi_msg_flash_ps_load_rsp_t *msg);

/**Erase the key and value from the persisten store.**/
void wifi_rsp_flash_ps_erase(const struct wifi_msg_flash_ps_erase_rsp_t *msg);

/**Device booted up in dfu, and is ready to receive commands**/
void wifi_evt_dfu_boot(const struct wifi_msg_dfu_boot_evt_t *msg);

/**Device booted up, and is ready to receive commands**/
void wifi_evt_system_boot(const struct wifi_msg_system_boot_evt_t *msg);

/**Current state of system**/
void wifi_evt_system_state(const struct wifi_msg_system_state_evt_t *msg);

/**Software exception occurred last time**/
void wifi_evt_system_sw_exception(const struct wifi_msg_system_sw_exception_evt_t *msg);

/**The current MAC address**/
void wifi_evt_config_mac_address(const struct wifi_msg_config_mac_address_evt_t *msg);

/**WiFi is on**/
void wifi_evt_sme_wifi_is_on(const struct wifi_msg_sme_wifi_is_on_evt_t *msg);

/**WiFi is off**/
void wifi_evt_sme_wifi_is_off(const struct wifi_msg_sme_wifi_is_off_evt_t *msg);

/**scan result**/
void wifi_evt_sme_scan_result(const struct wifi_msg_sme_scan_result_evt_t *msg);

/**Indicates that the Access Point was dropped from the modules BSSID filtering list.**/
void wifi_evt_sme_scan_result_drop(const struct wifi_msg_sme_scan_result_drop_evt_t *msg);

/**scanned status**/
void wifi_evt_sme_scanned(const struct wifi_msg_sme_scanned_evt_t *msg);

/**Connected to Access point**/
void wifi_evt_sme_connected(const struct wifi_msg_sme_connected_evt_t *msg);

/**Disconnected from the Access Point**/
void wifi_evt_sme_disconnected(const struct wifi_msg_sme_disconnected_evt_t *msg);

/**Network interface status**/
void wifi_evt_sme_interface_status(const struct wifi_msg_sme_interface_status_evt_t *msg);

/**Connect failed**/
void wifi_evt_sme_connect_failed(const struct wifi_msg_sme_connect_failed_evt_t *msg);

/**Connect retry**/
void wifi_evt_sme_connect_retry(const struct wifi_msg_sme_connect_retry_evt_t *msg);

/**TCP/IP configuration status**/
void wifi_evt_tcpip_configuration(const struct wifi_msg_tcpip_configuration_evt_t *msg);

/**DNS configuration status**/
void wifi_evt_tcpip_dns_configuration(const struct wifi_msg_tcpip_dns_configuration_evt_t *msg);

/**Describes the current status of a tcp/ip endpoint**/
void wifi_evt_tcpip_endpoint_status(const struct wifi_msg_tcpip_endpoint_status_evt_t *msg);

/**The event generated in response to a gethostbyname command. If the procedure was successful, this message contains the IP address of the queried address.**/
void wifi_evt_tcpip_dns_gethostbyname_result(const struct wifi_msg_tcpip_dns_gethostbyname_result_evt_t *msg);

/**Syntax error**/
void wifi_evt_endpoint_syntax_error(const struct wifi_msg_endpoint_syntax_error_evt_t *msg);

/**Incoming data from an endpoint**/
void wifi_evt_endpoint_data(const struct wifi_msg_endpoint_data_evt_t *msg);

/**status**/
void wifi_evt_endpoint_status(const struct wifi_msg_endpoint_status_evt_t *msg);

/**Endpoint is closing**/
void wifi_evt_endpoint_closing(const struct wifi_msg_endpoint_closing_evt_t *msg);

/**Soft timer event indicating a timer has lapsed**/
void wifi_evt_hardware_soft_timer(const struct wifi_msg_hardware_soft_timer_evt_t *msg);

/**Change notification**/
void wifi_evt_hardware_change_notification(const struct wifi_msg_hardware_change_notification_evt_t *msg);

/**External Interrupt**/
void wifi_evt_hardware_external_interrupt(const struct wifi_msg_hardware_external_interrupt_evt_t *msg);

/**Dump key result**/
void wifi_evt_flash_ps_key(const struct wifi_msg_flash_ps_key_evt_t *msg);



struct wifi_class_handler_t
{
    const struct wifi_msg **msgs;
    uint8 maxhandlers;
};
extern struct wifi_class_handler_t wifi_class_rsp_handlers[wifi_cls_last];
extern struct wifi_class_handler_t wifi_class_evt_handlers[wifi_cls_last];            
 
          
void wifi_default(const void*);
#ifdef __cplusplus
}
#endif
                 
#endif
