import QtQuick 1.0

Button
{
    id:a_button
    text:"Off"

    property string text_off:"Off"
    property string text_on:"On"
    property string text_wait:"Wait"

    property color button_color_off: bg_color.button_color_off
    property color light_color_off: bg_color.light_color_off
    property color dark_color_off: bg_color.dark_color_off
    property color text_color_off: bg_color.text_color_off

    property color button_color_on: bg_color.button_color_on
    property color light_color_on: bg_color.light_color_on
    property color dark_color_on: bg_color.dark_color_on
    property color text_color_on: bg_color.text_color_on

    states:
        [
        State
        {
            name: "off"
            PropertyChanges {target:a_button;  text:text_off }
            PropertyChanges {target:a_button;  text_color:text_color_off }
            PropertyChanges {target:a_button;  button_color:button_color_off }
            PropertyChanges {target:a_button;  light_color:light_color_off }
            PropertyChanges {target:a_button;  dark_color:dark_color_off }
        },
        State
        {
            name: "on"
            PropertyChanges {target:a_button;  text:text_on }
            PropertyChanges {target:a_button;  text_color:text_color_on }
            PropertyChanges {target:a_button;  button_color:button_color_on }
            PropertyChanges {target:a_button;  light_color:light_color_on }
            PropertyChanges {target:a_button;  dark_color:dark_color_on }
        },
        State
        {
            name: "wait"
            PropertyChanges {target:a_button;  text:text_wait }
            PropertyChanges {target:anim;  running:true}
        }
    ]

    SequentialAnimation
    {
        id:anim
        running:false
        loops:Animation.Infinite
        ParallelAnimation
        {
            ColorAnimation {target:a_button;property:"button_color"; to: button_color_on; duration: 500 }
            ColorAnimation {target:a_button;property:"light_color"; to: light_color_on; duration: 500 }
            ColorAnimation {target:a_button;property:"dark_color"; to: dark_color_on; duration: 500 }
        }
        ParallelAnimation
        {
            ColorAnimation {target:a_button;property:"button_color"; to: button_color_off; duration: 500 }
            ColorAnimation {target:a_button;property:"light_color"; to: light_color_off; duration: 500 }
            ColorAnimation {target:a_button;property:"dark_color"; to: dark_color_off; duration: 500 }
        }
    }
    Connections
    {
        target: system

        onEvt_boot:
        {
            a_button.state="off"
        }
    }
    Connections
    {
        target: dfu

        onEvt_boot:
        {
            a_button.state="off"
        }
    }
}
