import QtQuick 1.0

import "BGApi.js" as BGApi
ListView
{
    anchors.margins: 0
    currentIndex:-1
    id:listview
    boundsBehavior:Flickable.StopAtBounds
    model: ListModel {}
    property string selected_bssid
    delegate: dnsDelegate
    //highlight: Rectangle { color: "lightsteelblue"; radius: 5 }
    focus: true
    clip:true

    ScrollBar {
        id: verticalScrollBar
        width: 12;
        anchors.right: listview.right

        orientation: Qt.Vertical
        position: listview.visibleArea.yPosition
        anchors.top: parent.top
        anchors.topMargin: 1
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 1
        anchors.rightMargin: 1
        pageSize: listview.visibleArea.heightRatio
    }
    Component
    {
        id: dnsDelegate
        Item
        {
            id:epoint
            width: parent.width-verticalScrollBar.width; height: 40
            property real detailsOpacity : 0
            Rectangle
            {
                id:background
                anchors.margins:2
                anchors.fill:parent
                border.width: 1
                radius: 4
                smooth: true
                clip:true

                    Column
                    {
                        anchors.fill:parent
                        anchors.margins: 2
                        spacing:1
                        Text { text: name}
                        Text { text: address}
                    }
                }

            }


        }

    Connections {
        target: tcpip

        onQml_evt_dns_gethostbyname_result://(int result,int address,QString name);
        {
            if(result!=0)return;

            listview.model.append({"address":BGApi.int_to_ipaddress(address),"name":BGApi.bytearray_to_string(name)})
        }
    }
}
