// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1

import "BGApi.js" as BGApi
ListView
{
    anchors.margins: 1
    currentIndex:-1
    id:datalistview
    boundsBehavior:Flickable.StopAtBounds
    model: ListModel {}

    delegate: dataListDelegate
    //highlight: Rectangle { color: "lightsteelblue"; radius: 5 }
    focus: true
    clip:true

    ScrollBar {
        id: dataScrollBar
        y:0
        width: 12;
        height: datalistview.height
        anchors.right: datalistview.right
        orientation: Qt.Vertical
        position: datalistview.visibleArea.yPosition
        pageSize: datalistview.visibleArea.heightRatio
    }
    Component
    {
        id: dataListDelegate
        Rectangle {
            height: data_text.height+1
            color: "#00000000"
            width: parent.width-dataScrollBar.width;
            Text {
                id: data_text
                width: parent.width
                text: endpoint_index+": "+data_string
                wrapMode: Text.WrapAnywhere
            }
        }

    }

    Connections
    {
        target: endpoint

        onQml_evt_data://signal evt_data(int endpoint,string data)
        {
            datalistview.model.append({"endpoint_index":endpoint,"data_string":BGApi.bytearray_to_escaped_string(data)});
        }
    }

}
