import QtQuick 1.0

Item {
    width: 491
    height: 300
    anchors.fill : parent

    Column{
        id: column1
        spacing:5
        anchors.centerIn: parent
        Button
        {
            id: dfu_button

            text:"Boot into DFU mode"
            anchors.horizontalCenter: parent.horizontalCenter
            function clicked()
            {
                dfu.qml_cmd_reset(1)

            }
        }
        Row{
            id: row1
            spacing:2


            Text
            {
                x: 0
                text:"Selected firmware file:"
                anchors.verticalCenter: parent.verticalCenter
        }

            FramedTextInput
            {
                anchors.verticalCenter: parent.verticalCenter
                id:fileName
                width:300
                text:""

            }
            Button
            {
                text:"Browse..."
                anchors.verticalCenter: parent.verticalCenter
                function clicked()
                {
                    fileDialog.show()
                }
            }



        }
        Button
        {
            text:"Upload"
            anchors.horizontalCenter: parent.horizontalCenter
            function clicked()
            {
                mainobj.uploadFile(fileName.text);
            }
        }
        Text
        {
            id:percentValue
            text:""
            anchors.horizontalCenter: parent.horizontalCenter
            Connections
            {
                target: main

                onUpload_progress:
                {
                    var d=0
                    if(elapsed)
                    {
                        d=bytes/1024.0/elapsed*1000
                    }

                    percentValue.text=(bytes/1024.0).toFixed(2)+"/"+(total/1024.0).toFixed(2)+"KiB ("+d.toFixed(2)+"KiB/s)"
                }
            }

        }
        Text
        {
            text:"NOTE: Logging is disabled while upload is in progress"
            anchors.horizontalCenter: parent.horizontalCenter
        }

    }
    Connections
    {
        target: fileDialog

        onFileSelected:
        {
            fileName.text=file
        }
    }
}
