import QtQuick 1.0
import Qt 4.7

Rectangle
{
    property bool cancelable: true
    property alias sourceComponent: loader.sourceComponent
    property alias item: loader.item
    signal confirmed();
    color: "#80000000"

    id: page
    opacity: 0

    anchors.fill: parent
    MouseArea
    {
        anchors.fill:parent
        onClicked:
        {
        }

    }
    function forceClose()
    {
         page.opacity = 0;
     }

     function show()
    {
         page.opacity = 1;
     }
    Rectangle{
        anchors.top:loader.top
        anchors.topMargin:-5
        anchors.left:loader.left
        anchors.leftMargin:-5
        anchors.right:loader.right
        anchors.rightMargin:-5
        anchors.bottom:okButton.bottom
        anchors.bottomMargin: -10
        border.width: 1
        radius: 4

    }
    Loader
    {
        id:loader
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter

    }


    Button {
        id: okButton
        text: "Ok"

        anchors.top: loader.bottom; anchors.topMargin: 10
        anchors.right: loader.right; anchors.rightMargin: 10

        onClicked: {
            parent.confirmed();
            parent.forceClose();
        }
    }

    Button {
        id: cancelButton
        text: "Cancel"
        opacity: parent.cancelable?parent.opacity:0
        anchors.top: loader.bottom; anchors.topMargin: 10
        anchors.right: okButton.left; anchors.rightMargin: 10

        onClicked: {
            parent.forceClose();
        }
    }

    Behavior on opacity {
        NumberAnimation { properties:"opacity"; duration: 200 }
    }
}
