import QtQuick 1.0
import Qt 4.7

import "BGApi.js" as BGApi

Grid
{
    id: page
    columns:2
    spacing:2
    property bool   active:true
    property int    eptype:8
    property alias localport: localPort.text
    property alias remoteip: remoteIP.text
    property alias remoteport: remotePort.text
    property alias defaultroute: defaultRoute.text
    /*
    Text
    {
        id:activeText
        text:"Active"
    }
    Button
    {
        id:editCheck
        width:activeText.height-2
        height:activeText.height-2
        button_color: parent.active?"yellowgreen":"orange red"
        light_color: parent.active?"lawngreen":"tomato"
        function clicked()
        {
            parent.active=parent.active^1
        }
    }*/
    Text
    {
        text:"Type"
    }

    Column
    {

        Button
        {
            id:selectedEndpoint
            width:100
            text:BGApi.ep_name(eptype)
            function clicked()
             {
                endpointList.opacity=1
                selectedEndpoint.opacity=0
             }
        }

        Column
        {
            id:endpointList
            z:100
            width:100
            height:BGApi.ep_creatable.length*(selectedEndpoint.text.height+1)
            opacity:0
            spacing:1
            clip:true
            Repeater
            {
                model: BGApi.ep_creatable.length
                Button
                {
                    text:BGApi.ep_name(eptype)
                    property int    eptype:BGApi.ep_creatable[index]
                    width:100
                    function clicked()
                     {
                        page.eptype=eptype
                        endpointList.opacity=0
                        selectedEndpoint.opacity=1
                     }
                }
            }

            Behavior on height {
                NumberAnimation { properties:"height"; duration: 1000 }
            }
        }
    }


    Text
    {
        text:"Route"
    }
    FramedTextInput
    {
        id:defaultRoute
        validator: IntValidator{bottom: -1; top: 31;}
        text:page.defaultroute
        KeyNavigation.tab: localPort.input
    }

    Text
    {
        text:"Local port"
        opacity:eptype&(BGApi.ep_tcp_server|BGApi.ep_udp_server)?1:0
    }
    FramedTextInput
    {
        id:localPort
        validator: IntValidator{bottom: 0; top: 0xffff;}
        text:page.localport
        KeyNavigation.tab: remoteIP.input
        opacity:eptype&(BGApi.ep_tcp_server|BGApi.ep_udp_server)?1:0
    }

    Text
    {
        text:"Remote IP"
        opacity:eptype&(BGApi.ep_tcp|BGApi.ep_udp)?1:0
    }
    FramedTextInput
    {
        id:remoteIP
        inputMask:"000.000.000.000; "
        text:page.remoteip
        KeyNavigation.tab: remotePort.input
        opacity:eptype&(BGApi.ep_tcp|BGApi.ep_udp)?1:0
    }

    Text
    {
        text:"Remote port"
        opacity:eptype&(BGApi.ep_tcp|BGApi.ep_udp)?1:0
    }
    FramedTextInput
    {
        id:remotePort
        validator: IntValidator{bottom: 0; top: 0xffff;}
        text:page.remoteport
        opacity:eptype&(BGApi.ep_tcp|BGApi.ep_udp)?1:0
    }


}
