import QtQuick 1.0
import "BGApi.js" as BGApi
Row{
    anchors.centerIn: parent
    spacing:2

    Column{
        spacing:2

        Text {
            id: add_ep_label
            x: 0
            y: 0
            text: qsTr("Add Endpoint")
            font.pointSize: 8
        }

        BackgroundRectangle{
        id:background_rect
        width: add_col.width+4
        height: add_col.height+4


    Column {
        anchors.centerIn: parent
        anchors.margins:1

        id:add_col
        spacing:2

        EndpointPopup{id:add_ep}
        Button
        {
            id: add_ep_button
            text:"Add"

            function clicked()
            {
                if(add_ep.eptype==BGApi.ep_tcp_server)
                {
                    tcpip.qml_cmd_start_tcp_server (add_ep.localport,add_ep.defaultroute);
                }
                if(add_ep.eptype==BGApi.ep_tcp)
                {
                    tcpip.qml_cmd_tcp_connect(BGApi.ip_to_number(add_ep.remoteip),add_ep.remoteport,add_ep.defaultroute)
                }
                if(add_ep.eptype==BGApi.ep_udp_server)
                {
                    tcpip.qml_cmd_start_udp_server (add_ep.localport,add_ep.defaultroute);
                }
                if(add_ep.eptype==BGApi.ep_udp)
                {
                    tcpip.qml_cmd_udp_connect(BGApi.ip_to_number(add_ep.remoteip),add_ep.remoteport,add_ep.defaultroute)
                }
            }
        }


    }
    }
        Text
        {
            id: dns_label
            text:"DNS lookup"
        }

        DNSView
        {
            id:dns_view
            width:background_rect.width;
            height:400-background_rect.height

    }

    }

    Column {
        id: column1
        x: 0
        y: 0
        width: 200

        Text {
            id: endpoints_label
            text: qsTr("Endpoints")
            font.pointSize: 8
        }

        BackgroundRectangle
        {
            y: 0
            height: 419
            anchors.left: parent.left
            anchors.leftMargin: 0
            anchors.right: parent.right
            anchors.rightMargin: 0



            EndpointListView
            {
                id:ep_listview
                anchors.fill:parent
        }



        }

    }

    Column
    {
        x: 0

        Text {
            id: data_label
            text: qsTr("Data view")
            font.pointSize: 8
        }



        Row
        {

            id:rowREndpoint
            FramedTextInput
            {
                id:textRoute
                width:20
                validator: IntValidator{bottom: 0; top: 31;}
                text:"0"
            }
            Rectangle
            {
                border.width: 1
                width:inputBG.width-textRoute.width
                height:textRoute.height

                TextInput
                {
                    id:inputEdit
                    text:""
                    anchors.fill:parent
                    anchors.margins: 2

                    onAccepted:
                    {
                        var n;
                        var s;
                        var blen=0xff
                        for(n=0;n<inputEdit.text.length;n+=blen)
                        {
                            s=BGApi.string_to_bytearray(inputEdit.text.slice(n,n+blen));
                            endpoint.qml_cmd_send (textRoute.text,s);
                        }
                        endpoint.qml_cmd_send (textRoute.text,"0a");
                        inputEdit.text=""
                    }
                }

            }
        }


        Rectangle {
            id: rectangle1
            width: 20
            height: 2
            color: "#00000000"
        }

        BackgroundRectangle
        {
            width:240; height:400
            id:inputBG
            y: 0

            DataListView
            {

                    id:dataList
                    anchors.rightMargin: 2
                    anchors.leftMargin: 2
                    anchors.bottomMargin: 2
                    anchors.topMargin: 2
                    anchors.fill: parent

            }
        }



    }


}
