import QtQuick 1.0
Item
{
    anchors.fill: parent

Grid
{
    id: grid1
    anchors.centerIn: parent
    width: 920
    height: 500
    rows:4
    columns:2
    flow:Grid.TopToBottom

    spacing:2


    IOPort
    {
        id: portb
        width: 565
        ioport:1
        text:"Port B"
    }
    IOPort
    {
        id: portc
        ioport:2
        text:"Port C"
    }
    IOPort
    {
        id: portd
        ioport:3
        text:"Port D"
    }


    Column
    {
        x: 0

        spacing:2

        Rectangle {
            id: spacer1
            width: 10
            height: 8
            color: "#00000000"
        }

        Text
        {
            text:"Change notification"
        }
        IOPortButton
        {
            id:change_notification
            button_text:"Enable"
            function clicked()
            {
                hardware.cmd_change_notification_config (parseInt(change_notification.text,16));
            }
        }

        IOPortButton
        {
            id:pullup
            button_text:"Pull-up"
            function clicked()
            {
                hardware.cmd_change_notification_pullup (parseInt(pullup.text,16));
            }
        }

    }


    IOPort
    {
        id: porte
        ioport:4
        number_bits: 8
        text:"Port E"
    }

    IOPort
    {
        id: portf
        ioport:5
        number_bits: 8
        text:"Port F"
    }




    IOPort
    {
        id: portg
        ioport:6
        number_bits: 8
        text:"Port G"
    }


    Column
    {
        x: 511
        Rectangle {
            id: spacer2
            width: 10
            height: 8
            color: "#00000000"
        }

        Text
        {
            text:"External interrupt"
        }

        IOPortButton
        {
            id:ext_irq_enable
            number_bits:5
            button_text:"Enable"
            function clicked()
            {
                hardware.cmd_external_interrupt_config (parseInt(ext_irq_enable.text,16),parseInt(ext_irq_polarity.text,16));
            }
        }

        IOPortButton
        {
            id:ext_irq_polarity
            number_bits:5
            button_text:"Rising edge"
            function clicked()
            {
                hardware.cmd_external_interrupt_config (parseInt(ext_irq_enable.text,16),parseInt(ext_irq_polarity.text,16));
            }
        }

    }
}
}
