import QtQuick 1.0

Column
{
    spacing:2
    property int ioport: 0
    property alias text: port_label.text
    property int number_bits: 16
    Text
    {
        id:port_label
        text:""
    }

    IOPortButton
    {
        id:direction
        button_text:"Set Direction"
        text:"0"
        value:0
        number_bits: parent.number_bits
        function clicked()
        {
            hardware.qml_cmd_io_port_config_direction(ioport,0xffff,parseInt(direction.text,16));
        }
    }
    IOPortButton
    {
        id:open_drain
        button_text:"Set Open drain"
        number_bits: parent.number_bits
        function clicked()
        {
            hardware.qml_cmd_io_port_config_open_drain(ioport,0xffff,parseInt(open_drain.text,16));
        }
    }
    IOPortButton
    {
        id:write
        button_text:"Write bits"
        number_bits: parent.number_bits
        function clicked()
        {
            hardware.qml_cmd_io_port_write(ioport,0xffff,parseInt(write.text,16));
        }
    }

    IOPortButton
    {
        id:read
        button_text:"Read bits"
        number_bits: parent.number_bits
        function clicked()
        {
            hardware.qml_cmd_io_port_read(ioport,0xffff);
        }
    }
    Connections
    {
        target: hardware

//        void qml_rsp_io_port_read (int result,int port,int data);

        onQml_rsp_io_port_read:
        {
            if(result!=0)
                return;
            if(port==ioport)
            {
                read.value=data;
            }
        }
    }
}
