import QtQuick 1.0

Row
{
    id:io
    spacing:2
    property alias button_text: io_button.text
    property alias text: value.text
    property int value:0
    property int number_bits:16
    signal clicked

    Text
    {
        anchors.verticalCenter: parent.verticalCenter
    }

    Repeater
    {
        id:bits
        model: number_bits
        Rectangle
        {
            anchors.verticalCenter: parent.verticalCenter
            width: parent.height-3;
            height: parent.height-3;
            border.width: 1
            color: io.value&(1<<index)?"lawngreen":"#00000000"
            Text
            {
                anchors.centerIn: parent
                text:index
            }

            MouseArea
            {
                anchors.fill: parent
                onClicked:
                {
                    var val=parseInt(value.text,16);
                    var mask=1<<index
                    io.value^=mask
                    value.text=io.value.toString(16)
                }
            }
        }
    }
    FramedTextInput
    {
        id:value
        anchors.verticalCenter: parent.verticalCenter
        //validator: IntValidator { bottom:0; top: 0xffff}
        inputMask:"hhhh"
        text:"0"
        width:50

        onAccepted:
        {
            var val=parseInt(value.text,16);

            io.value=val
        }
    }
    onValueChanged:
    {
        value.text=io.value.toString(16)
    }

    Button
    {
        id:io_button
        function clicked()
        {
            io.clicked();
        }
    }
}
