import QtQuick 1.0

import "BGApi.js" as BGApi

ListView
{
    anchors.margins: 1
    currentIndex:-1
    id:listview
    boundsBehavior:Flickable.StopAtBounds
    model: ListModel {}
    property string selected_bssid
    delegate: psDelegate
    //highlight: Rectangle { color: "lightsteelblue"; radius: 5 }
    focus: true
    clip:true

    ScrollBar {
        id: verticalScrollBar
        y:1
        width: 12; height: listview.height
        anchors.right: listview.right
        orientation: Qt.Vertical
        position: listview.visibleArea.yPosition
        pageSize: listview.visibleArea.heightRatio
    }
    Component
    {
        id: psDelegate
        Item
        {
            id:epoint
            width: parent.width-verticalScrollBar.width; height: 40
            property real detailsOpacity : 0
            Rectangle
            {
                id:background
                anchors.margins:2
                anchors.fill:parent
                border.width: 1
                radius: 4
                smooth: true
                clip:true

                    Column
                    {
                        anchors.fill:parent
                        anchors.margins: 2
                        spacing:1
                        Text { text: "Key: "+key}
                        Text { text: "Value: "+value}
                    }
                }

            }


        }

    Connections {
        target: flash
        onQml_rsp_ps_dump:
        {
            listview.model.clear();
        }

        onQml_evt_ps_key://(int result,int address,QString name);
        {
            if(key!=0xffff)
                listview.model.append({"key":key,"value":value})
        }
    }
}
