.pragma library

/*
 * Array wrapper
 */
Array.prototype.remove = function(from, to) {
   var rest = this.slice((to || from) + 1 || this.length);
   this.length = from < 0 ? this.length + from : from;
   return this.push.apply(this, rest);
};
// .attach() method to JavaScript Arrays: attaches a QML ListModel to an array
Array.prototype.attach = function(listmodel) {
    this.__model = listmodel;
    this.flush();
}

// .flush() method to JavaScript Arrays: updates the attached ListModel to the contents of the Array
// automatically creates a role "value" for the ListModel if the array is flat
Array.prototype.flush = function() {
    var i;
    this.__model.clear();
    //while (this.__model.count > this.length) this.__model.remove(this.__model.count-1);
    for (i = 0; i < this.__model.count; i++) this.__model.set(i, typeof this[i] === 'object' ? this[i] : {value: this[i]});
    for (;i < this.length; i++) this.__model.append(typeof this[i] === 'object' ? this[i] : {value: this[i]});
//  this.__model.sync();        // The model.sync() is only for updates in WorkerScript - see next example
}
var scanArray = [];   // This is the array to work with, you can initialize it here

var update = function(ap)
{
    for(var i=0; i<scanArray.length; i++)
    {
        if(scanArray[i].bssid==ap.bssid)
        {
            scanArray[i]=ap
            return;
        }
    }
    scanArray.push(ap)
}
function clear()
{
    scanArray.length=0;
    scanArray.flush();
}
function drop(bssid)
{
    for(var i=0; i<scanArray.length; i++)
    {
        if(scanArray[i].bssid==bssid)
        {
            scanArray.remove(i);
            scanArray.flush();
            return;
        }
    }
}


var init = function(listModel) { // QML calls when ready
 // Do the final initializations here

    scanArray.attach(listModel);    // And finally attach the listModel to the array
}
var sort_by_rssi=function(a,b)
{
    return b.rssi-a.rssi;
}
var sort_by_bssid=function(a,b)
{
    return a.bssid.localeCompare(b.bssid);
}
var sort_by_ssid=function(a,b)
{
    return a.ssid.toLowerCase().localeCompare(b.ssid.toLowerCase());
}
var sort_function=sort_by_rssi
var sort = function()
{
    scanArray.sort(sort_function);
    scanArray.flush();    // and finally update the ListModel
}

