import QtQuick 1.0

Row
{
    anchors.top:parent.top
    anchors.horizontalCenter: parent.horizontalCenter

    Button
    {
        id: reset_button

        text:"Reset"
        function clicked()
        {
            dfu.qml_cmd_reset(0)

        }
    }
    Rectangle
    {
        id: com_sel


        height: reset_button.height-1; width: text.width + 20
        border.width: 1
        radius: 4
        smooth: true
        //color:"red"
        Behavior on color {
            ColorAnimation {}
        }
        Text {
            id: text
            anchors.centerIn:parent
            font.pointSize: 10
            text: ""
            color:main.attached==true?bg_color.white:bg_color.black
        }
        states:
            [
            State
            {
                name: "attached"
                when: main.attached==true
                PropertyChanges { target: com_sel;color: bg_color.blue}
            }
        ]
        Connections
        {
            target: main
            onAttached:
            {
                com_sel.state = attached ? "attached" : ""
                text.text=port+" : "+baud

            }
        }
    }
    Button
    {
        id: sync
        opacity:main.attached==true?1:0
        text:"Retrieve info"
        function clicked()
        {
            system.cmd_sync()
        }
    }
}
