import QtQuick 1.0

ListView
{
    signal selected(int selection)

    function item(i)
    {
        return model.get(currentIndex)
    }

    id:listview

    anchors.fill:parent
    currentIndex:-1

    clip:true
    highlightFollowsCurrentItem: true
    boundsBehavior: Flickable.StopAtBounds

    model: ListModel {}
    delegate: portDelegate
    highlight: highlight
    focus: true

    Component
    {
        id: portDelegate
        Item
        {

            width: parent.width; height: txt.height*2
            Text
            {
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: parent.left
                anchors.leftMargin: 5
                id:txt
                text: name

            }

            MouseArea
            {
                anchors.fill: parent
                onClicked:
                {
                    listview.selected(index)
                    listview.currentIndex = index;
                }

            }
        }
    }
    Component
    {
        id: highlight
        Rectangle
        {

            color: bg_color.blue2; radius: 5


        }
    }


}
